#ifndef filval_hpp
#define filval_hpp
#define FILVAL_VERSION_MAJOR @FILVAL_VERSION_MAJOR@
#define FILVAL_VERSION_MINOR @FILVAL_VERSION_MINOR@
#include "value.hpp"
#include "container.hpp"
#include "dataset.hpp"
#include "log.hpp"
#include "argparse.hpp"
#include "config.hpp"
#include "memtrack.hpp"

namespace fv {
    template<typename T>
    Value<T> *lookup(const std::string &name) {
        Value<T> *tv = GenValue::get_value<T>(name);
        if (tv == nullptr) {
            CRITICAL("Could not find alias or value \"" << name << "\"."
                                                        << " I'll tell you the ones I know about." << std::endl
                                                        << GenValue::summary(), -1);
        }
        return tv;
    }

    template<typename T>
    bool check_exists(const std::string name) {
        Value<T> *tv = GenValue::get_value<T>(name);
        return tv != nullptr;
    }
}

#endif // filval_hpp
